unit Unit_LGS;

interface   // abgespeckte Version

const MaxCount  = 10;
type  TEquation = Array [0..MaxCount] of Double;
var   EquaCount,
      VarCount  : Integer;

procedure SetEquation(nr: Integer; koeff: TEquation);
  { schreibt die Koeffizienten der bergebenen Gleichung als nr-te
    Gleichung in das Gleichungssystem }

procedure GetEquation(nr: Integer; var koeff: TEquation);
  { liest die Koeffizienten der nr-ten Gleichung aus dem Gleichungssystem
    und bergibt sie in der Gleichung koeff }

procedure Diagonalize;
  { bringt das Gleichungssystem auf Diagonalform }


implementation

var ko : Array [0..MaxCount, 0..MaxCount] of Double;  // lokale Deklaration

procedure SetEquation(nr: Integer; koeff: TEquation);
  var i : Integer;
  begin
  For i := 0 to Varcount do
    ko[i, nr] := koeff[i];
  end;

procedure GetEquation(nr: Integer; var koeff: TEquation);
  var i : Integer;
  begin
  For i := 0 to VarCount do
    koeff[i] := ko[i, nr];
  end;

procedure ExchangeEquations(n1, n2: Integer);
  { vertauscht die n1-te mit der n2-ten Gleichung }
  var pu : Double;
      i  : Integer;
  begin
  If n1 <> n2 then
    For i := 0 to VarCount do begin
      pu        := ko[i, n1];
      ko[i, n1] := ko[i, n2];
      ko[i, n2] := pu;
      end;
  end;

procedure DivideEquation(nr: Integer; factor: Double);
  { diviert die nr-te Gleichung durch factor }
  var i : Integer;
  begin
  For i := 0 to VarCount do
    ko[i, nr] := ko[i, nr] / factor;
  end;

procedure SubtEquation(dest: Integer; factor: Double; source: Integer);
  { subtrahiert von der dest-ten Gleichung das factor-fache der
    source-ten Gleichung und schreibt die neuen Koeffizienten in die
    dest-te Gleichung zurck }
  var i : Integer;
  begin
  For i := 0 to VarCount do
    ko[i, dest] := ko[i, dest] - ko[i, source] * factor;
  end;

procedure Diagonalize;
  var i, k, m : Integer;
  begin
  If EquaCount >= VarCount then   // korrekte Grenze fr nicht-
    m := VarCount                 //   quadratische Systeme!
  else
    m := EquaCount;
  For k := 1 to m do begin
    DivideEquation(k, ko[k,k]);
    For i:= 1 to EquaCount do
      If i <> k then
        SubtEquation(i, ko[k,i], k);
    end;
  end;

end.
